<?php
function ombutel_populate_contexts_from_tenants() {
   $panelcontexts[0]='GENERAL';
   return $panelcontexts;
}

// Same as functions-astdb but querying the asterisk database for sip peers and voicemail tables
function ombutel_check_extension_usage() {
    global $db, $astman, $conf;
    $extenlist = array();


    $extensions = json_decode(file_get_contents('http://localhost/api/extensions'));
    foreach($extensions->data as $extension) {
        $device  = "SIP/{$extension->extension}";
        $mailbox = $extension->mailbox;
        $fullcid = $extension->internal_cid;
        if(preg_match("/</",$fullcid)) {
            $partes  = preg_split("/</",$fullcid);
            $cidnum  = substr(trim($partes[1]),0,-1);
            $cidname = substr(trim($partes[0]),1,-1);
            $fullcid = $cidname;
        }
 
        $data = array();
        $data['context_id'] = 0; 
        $data['type']       = 'extension';
        $data['channel']    = $device;
        $data['name']       = $cidname;
        $data['exten']      = $extension->extension;
        $data['mailbox']    = $mailbox;
        $data['context']    = 'cos-all';
    
        $extenlist[$device] = $data;
 
    }

    // Queues
    if(is_readable("/etc/asterisk/queues.conf")) { 
        $lines = file("/etc/asterisk/queues.conf");
        $data = array();
        $cont=0;
        foreach($lines as $line) {
            $line=trim($line);
            if(preg_match("/^\[/",$line)) {
                $cont++;
                $queue = substr($line,1,-1);
                $data['channel'] = "QUEUE/$queue";
                $data['type']    = "queue";
                $data['context'] = "default";
                $data['name']    = $queue;
                $data['exten']   = $cont;
                $data['context_id'] = 0; 
                $extenlist[$data['channel']] = $data;
            }
        }
    }

    // Conferences 
    if(is_readable("/etc/asterisk/meetme.conf")) {
        $lines = file("/etc/asterisk/meetme.conf");
        $data = array();
        $cont=0;
        foreach($lines as $line) {
            $line=trim($line);

            if(preg_match("/^conf =>/",$line)) {
                $partes = preg_split("/=>/",$line);
                $pertes = preg_split("/,/",$partes[1]);
                $value = trim($pertes[0]);
                $data['type']    = 'conference';
                $data['context'] = 'default';
                $data['exten'] = $value;
                $data['channel'] = "CONFERENCE/".$value;
                $data['context_id'] = 0; 
                $extenlist[$data['channel']] = $data;
            }

        }
    }

    if(!$res = $astman->connect("localhost:".$conf["MGRPORT"], $conf["MGRUSER"] , $conf["MGRPASS"], 'off')) {
        unset($astman);
    }

    if($astman) {
        $get = $astman->Command('dialplan show parkedcalls');
        if(is_array($get)) {

            $get = array_shift($get);
            $lines = preg_split("/\n/",$get);
            foreach($lines as $line) {
                $line = trim($line);
                if(preg_match("/Context/",$line)) {
                    $partes = preg_split("/ /",$line);
                    $context = substr(trim($partes[2]),1,-1);
                }
                if(preg_match("/=>/",$line)) {
                    $partes = preg_split("/=>/",$line);
                    $park_exten = substr(trim($partes[0]),1,-1);
                    if($context=='parkedcalls') {
                        $channel = "PARK/default";
                        $name = 'Default';
                    } else {
                        $partes = preg_split("/_/",$context);
                        $channel = "PARK/parkinglot_".$partes[1];
                        $name = $partes[1];
                    }
                    $data = array();
                    $data['name']    = $name;
                    $data['channel'] = $channel;
                    $data['type']    = 'park';
                    $data['exten']   = $park_exten;
                    $data['context'] = $context;
                    $data['context_id'] = 0; 
                    $extenlist[$data['channel']]  = $data;
                }
            }
        }
    }
    return $extenlist;

}
